{
  description = "ocaml-re flake";

  inputs.nix-filter.url = "github:numtide/nix-filter";
  inputs.flake-utils.url = "github:numtide/flake-utils";
  inputs.nixpkgs.url = "github:nix-ocaml/nix-overlays";

  outputs = { self, nixpkgs, flake-utils, nix-filter }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = nixpkgs.legacyPackages."${system}";
        inherit (pkgs.ocamlPackages) buildDunePackage;
      in rec {
        packages = rec {
          default = re;
          re = buildDunePackage {
            pname = "re";
            version = "n/a";
            src = ./.;
            duneVersion = "3";
            propagatedBuildInputs = with pkgs.ocamlPackages; [ seq ];
            checkInputs = with pkgs.ocamlPackages; [ ounit ];
            doCheck = true;
          };
        };
        devShells.default = pkgs.mkShell {
          inputsFrom = pkgs.lib.attrValues packages;
          buildInputs = with pkgs.ocamlPackages; [
            ocaml-lsp
            core_bench
            pkgs.ocamlformat_0_26_2
            js_of_ocaml
            pkgs.nodejs-slim
          ];
        };
      });
}
